/* FILE: atlasscalarfieldinit.h      -*-Mode: c++-*-
 *
 * Atlas scalar field initializer, derived from Oxs_ScalarFieldInit
 * class.
 *
 */

#ifndef _OXS_ATLASSCALARFIELDINIT
#define _OXS_ATLASSCALARFIELDINIT

#include <string>
#include <vector>

#include "oc.h"

#include "atlas.h"
#include "scalarfieldinit.h"

/* End includes */

class Oxs_AtlasScalarFieldInit:public Oxs_ScalarFieldInit {
private:
  Oxs_Key<Oxs_Atlas> atlaskey;  
  vector<REAL8m> values;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_AtlasScalarFieldInit
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   Tcl_Interp* safe_interp, // Safe interpreter
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_AtlasScalarFieldInit() {}

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<REAL8m>& array) const;

};

#endif // _OXS_ATLASSCALARFIELDINIT
