/* FILE: scriptscalarfieldinit.h      -*-Mode: c++-*-
 *
 * Tcl script scalar field initializer, derived from Oxs_ScalarFieldInit
 * class.
 *
 */

#ifndef _OXS_SCRIPTSCALARFIELDINIT
#define _OXS_SCRIPTSCALARFIELDINIT

#include <string>
#include <vector>

#include "oc.h"

#include "scalarfieldinit.h"

/* End includes */

class Oxs_ScriptScalarFieldInit:public Oxs_ScalarFieldInit {
private:
  Tcl_Interp* const safe_interp;
  vector<string> scriptlist;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_ScriptScalarFieldInit
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   Tcl_Interp* safe_interp, // Safe interpreter
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_ScriptScalarFieldInit() {}

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<REAL8m>& array) const;

};


#endif // _OXS_SCRIPTSCALARFIELDINIT
