/* FILE: scriptvectorfieldinit.h      -*-Mode: c++-*-
 *
 * Tcl script vector field initializer, derived from Oxs_VectorFieldInit
 * class.
 *
 */

#ifndef _OXS_SCRIPTVECTORFIELDINIT
#define _OXS_SCRIPTVECTORFIELDINIT

#include <string>
#include <vector>

#include "oc.h"

#include "vectorfieldinit.h"

/* End includes */

class Oxs_ScriptVectorFieldInit:public Oxs_VectorFieldInit {
private:
  Tcl_Interp* const safe_interp;
  BOOL set_norm;
  REAL8m norm;
  vector<string> scriptlist;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_ScriptVectorFieldInit
  (const char* name,     // Child instance id
   Oxs_Director* newdtr, // App director
   Tcl_Interp* safe_interp, // Safe interpreter
   const char* argstr);  // MIF input block parameters

  virtual ~Oxs_ScriptVectorFieldInit() {}

  virtual void FillMeshValue(const Oxs_Mesh* mesh,
			     Oxs_MeshValue<ThreeVector>& array) const;

};


#endif // _OXS_SCRIPTVECTORFIELDINIT
